package com.yaohun.enderdragonwar.effect.types;

import com.io.yutian.pixelliveapi.api.PixelLiveAPI;
import com.yaohun.enderdragonwar.EnderDragonWar;
import com.yaohun.enderdragonwar.effect.GameGiftEffect;
import com.yaohun.enderdragonwar.game.Game;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

public class RandomBoxEffect extends GameGiftEffect {

    public RandomBoxEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        Player player = game.getPlayer();
        List<String> list = getEffects();
        Collections.shuffle(list);
        Random random = new Random();
        String eventName = list.get(random.nextInt(list.size()));
        BukkitTask task = new BukkitRunnable() {
            private int i = 0;
            @Override
            public void run() {
                if (i >= 12) {
                    player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + eventName);
                    player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                    PixelLiveAPI.getEffectQueueManager().addEffect(getAudience(), eventName, 1);
                    Bukkit.broadcastMessage("§c[消息]§a随机盲盒抽中了 §e" + eventName);
                    cancel();
                    return;
                }
                player.sendTitle("§6随机盲盒", "§9整蛊效果: §e" + list.get(random.nextInt(list.size())));
                player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 1);
                i++;
            }
        }.runTaskTimer(EnderDragonWar.plugin, 0L, 5L);
        EnderDragonWar.game.addTasks(task);
    }

    private List<String> getEffects() {
        List<String> stringList = new ArrayList<>();
        stringList.add("清理背包");
        stringList.add("清理背包");
        stringList.add("火山喷发");
        stringList.add("幸运方块");
        stringList.add("幸运方块");
        stringList.add("幸运方块");
        stringList.add("黑洞");
        stringList.add("黑洞");
        stringList.add("五雷轰顶");
        stringList.add("五雷轰顶");
        stringList.add("五雷轰顶");
        stringList.add("五雷轰顶");
        stringList.add("五雷轰顶");
        stringList.add("装备清空");
        stringList.add("装备清空");
        stringList.add("岩浆泡澡");
        stringList.add("岩浆泡澡");
        stringList.add("岩浆泡澡");
        stringList.add("钢铁保安");
        stringList.add("钢铁保安");
        stringList.add("钢铁保安");
        stringList.add("钢铁保安");
        stringList.add("6倍血量");
        stringList.add("6倍血量");
        stringList.add("原地复活");
        stringList.add("原地复活");
        stringList.add("原地复活");
        stringList.add("原地复活");
        stringList.add("变大");
        stringList.add("变小");
        stringList.add("变大");
        stringList.add("变小");
        stringList.add("变大");
        stringList.add("变小");
        stringList.add("安全庇护所");
        stringList.add("怪物军团");
        stringList.add("安全庇护所");
        stringList.add("怪物军团");
        stringList.add("安全庇护所");
        stringList.add("怪物军团");
        stringList.add("安全庇护所");
        stringList.add("怪物军团");
        stringList.add("螺旋升天");
        stringList.add("魔豆天梯");
        return stringList;
    }

}
